diff --git a/appimage/Extera.AppDir/bundle/data/flutter_assets/packages/record_web/assets/js/record.worklet.js b/appimage/Extera.AppDir/bundle/data/flutter_assets/packages/record_web/assets/js/record.worklet.js
new file mode 100644
index 0000000..9254b7f
--- /dev/null
+++ b/appimage/Extera.AppDir/bundle/data/flutter_assets/packages/record_web/assets/js/record.worklet.js
@@ -0,0 +1,407 @@
+class RecorderProcessor extends AudioWorkletProcessor {
+  static get parameterDescriptors() {
+    return [
+      {
+        name: 'numChannels',
+        defaultValue: 1,
+        minValue: 1,
+        maxValue: 16
+      },
+      {
+        name: 'sampleRate',
+        defaultValue: 48000,
+        minValue: 8000,
+        maxValue: 96000
+      },
+      {
+        name: 'streamBufferSize',
+        defaultValue: 2048,
+        minValue: 256,
+        maxValue: 8192
+      }
+    ];
+  }
+
+  // Buffer size compromise between size and process call frequency
+  _bufferSize = 2048
+  // The current buffer fill level
+  _bytesWritten = 0
+  // Buffer per channel
+  _buffers = []
+  // Resampler (passthrough, down or up)
+  _resampler = null
+  // Config
+  _numChannels = 1
+  _sampleRate = 48000
+
+  constructor(options) {
+    super(options)
+
+    this._numChannels = options.parameterData.numChannels
+    this._sampleRate = options.parameterData.sampleRate
+    this._bufferSize = options.parameterData.streamBufferSize
+
+    // Resampler(current context sample rate, desired sample rate, num channels, buffer size)
+    // num channels is always 1 since we resample after interleaving channels
+    this._resampler = new Resampler(sampleRate, this._sampleRate, 1, this._bufferSize * this._numChannels)
+
+    this.initBuffers()
+  }
+
+  initBuffers() {
+    this._bytesWritten = 0
+    this._buffers = []
+
+    for (let channel = 0; channel < this._numChannels; channel++) {
+      this._buffers[channel] = []
+    }
+  }
+
+  /**
+   * @returns {boolean}
+   */
+  isBufferEmpty() {
+    return this._bytesWritten === 0
+  }
+
+  /**
+   * @returns {boolean}
+   */
+  isBufferFull() {
+    return this._bytesWritten >= this._bufferSize
+  }
+
+  /**
+   * @param {Float32Array[][]} inputs
+   * @returns {boolean}
+   */
+  process(inputs) {
+    if (this.isBufferFull()) {
+      this.flush()
+    }
+
+    const input = inputs[0]
+
+    if (input.length == 0) {
+      // Sometimes, Firefox doesn't give any input. Skip this frame to not fail.
+      return true
+    }
+
+    for (let channel = 0; channel < this._numChannels; channel++) {
+      // Push a copy of the array.
+      // The underlying implementation may reuse it which will break the recording.
+      this._buffers[channel].push([...input[channel % input.length]])
+    }
+
+    this._bytesWritten += input[0].length
+
+    return true
+  }
+
+  flush() {
+    let channels = []
+    for (let channel = 0; channel < this._numChannels; channel++) {
+      channels.push(this.mergeFloat32Arrays(this._buffers[channel], this._bytesWritten))
+    }
+
+    let interleaved = this.interleave(channels)
+
+    let resampled = this._resampler.resample(interleaved)
+
+    this.port.postMessage(this.floatTo16BitPCM(resampled))
+
+    this.initBuffers()
+  }
+
+  mergeFloat32Arrays(arrays, bytesWritten) {
+    let result = new Float32Array(bytesWritten)
+    var offset = 0
+
+    for (let i = 0; i < arrays.length; i++) {
+      result.set(arrays[i], offset)
+      offset += arrays[i].length
+    }
+
+    return result
+  }
+
+  // Interleave data from channels from LLLLRRRR to LRLRLRLR
+  interleave(channels) {
+    if (channels === 1) {
+      return channels[0]
+    }
+
+    var length = 0
+    for (let i = 0; i < channels.length; i++) {
+      length += channels[i].length
+    }
+
+    let result = new Float32Array(length)
+
+    var index = 0
+    var inputIndex = 0
+
+    while (index < length) {
+      for (let i = 0; i < channels.length; i++) {
+        result[index] = channels[i][inputIndex]
+        index++
+      }
+
+      inputIndex++
+    }
+
+    return result
+  }
+
+  floatTo16BitPCM(input) {
+    let output = new DataView(new ArrayBuffer(input.length * 2))
+
+    for (let i = 0; i < input.length; i++) {
+      let s = Math.max(-1, Math.min(1, input[i]))
+      let s16 = s < 0 ? s * 0x8000 : s * 0x7FFF
+      output.setInt16(i * 2, s16, true)
+    }
+
+    return new Int16Array(output.buffer)
+  }
+}
+
+class Resampler {
+  constructor(fromSampleRate, toSampleRate, channels, inputBufferSize) {
+
+    if (!fromSampleRate || !toSampleRate || !channels) {
+      throw (new Error("Invalid settings specified for the resampler."));
+    }
+    this.resampler = null;
+    this.fromSampleRate = fromSampleRate;
+    this.toSampleRate = toSampleRate;
+    this.channels = channels || 0;
+    this.inputBufferSize = inputBufferSize;
+    this.initialize()
+  }
+
+  initialize() {
+    if (this.fromSampleRate == this.toSampleRate) {
+
+      // Setup resampler bypass - Resampler just returns what was passed through
+      this.resampler = (buffer) => {
+        return buffer
+      };
+      this.ratioWeight = 1;
+
+    } else {
+      if (this.fromSampleRate < this.toSampleRate) {
+
+        // Use generic linear interpolation if upsampling,
+        // as linear interpolation produces a gradient that we want
+        // and works fine with two input sample points per output in this case.
+        this.linearInterpolation();
+        this.lastWeight = 1;
+
+      } else {
+
+        // Custom resampler I wrote that doesn't skip samples
+        // like standard linear interpolation in high downsampling.
+        // This is more accurate than linear interpolation on downsampling.
+        this.multiTap();
+        this.tailExists = false;
+        this.lastWeight = 0;
+      }
+
+      // Initialize the internal buffer:
+      this.initializeBuffers();
+      this.ratioWeight = this.fromSampleRate / this.toSampleRate;
+    }
+  }
+
+  bufferSlice(sliceAmount) {
+
+    //Typed array and normal array buffer section referencing:
+    try {
+      return this.outputBuffer.subarray(0, sliceAmount);
+    }
+    catch (error) {
+      try {
+        //Regular array pass:
+        this.outputBuffer.length = sliceAmount;
+        return this.outputBuffer;
+      }
+      catch (error) {
+        //Nightly Firefox 4 used to have the subarray function named as slice:
+        return this.outputBuffer.slice(0, sliceAmount);
+      }
+    }
+  }
+
+  initializeBuffers() {
+    this.outputBufferSize = (Math.ceil(this.inputBufferSize * this.toSampleRate / this.fromSampleRate / this.channels * 1.000000476837158203125) + this.channels) + this.channels;
+    try {
+      this.outputBuffer = new Float32Array(this.outputBufferSize);
+      this.lastOutput = new Float32Array(this.channels);
+    }
+    catch (error) {
+      this.outputBuffer = [];
+      this.lastOutput = [];
+    }
+  }
+
+  linearInterpolation() {
+    this.resampler = (buffer) => {
+      let bufferLength = buffer.length,
+        channels = this.channels,
+        outLength,
+        ratioWeight,
+        weight,
+        firstWeight,
+        secondWeight,
+        sourceOffset,
+        outputOffset,
+        outputBuffer,
+        channel;
+
+      if ((bufferLength % channels) !== 0) {
+        throw (new Error("Buffer was of incorrect sample length."));
+      }
+      if (bufferLength <= 0) {
+        return [];
+      }
+
+      outLength = this.outputBufferSize;
+      ratioWeight = this.ratioWeight;
+      weight = this.lastWeight;
+      firstWeight = 0;
+      secondWeight = 0;
+      sourceOffset = 0;
+      outputOffset = 0;
+      outputBuffer = this.outputBuffer;
+
+      for (; weight < 1; weight += ratioWeight) {
+        secondWeight = weight % 1;
+        firstWeight = 1 - secondWeight;
+        this.lastWeight = weight % 1;
+        for (channel = 0; channel < this.channels; ++channel) {
+          outputBuffer[outputOffset++] = (this.lastOutput[channel] * firstWeight) + (buffer[channel] * secondWeight);
+        }
+      }
+      weight -= 1;
+      for (bufferLength -= channels, sourceOffset = Math.floor(weight) * channels; outputOffset < outLength && sourceOffset < bufferLength;) {
+        secondWeight = weight % 1;
+        firstWeight = 1 - secondWeight;
+        for (channel = 0; channel < this.channels; ++channel) {
+          outputBuffer[outputOffset++] = (buffer[sourceOffset + ((channel > 0) ? (channel) : 0)] * firstWeight) + (buffer[sourceOffset + (channels + channel)] * secondWeight);
+        }
+        weight += ratioWeight;
+        sourceOffset = Math.floor(weight) * channels;
+      }
+      for (channel = 0; channel < channels; ++channel) {
+        this.lastOutput[channel] = buffer[sourceOffset++];
+      }
+      return this.bufferSlice(outputOffset);
+    };
+  }
+
+  multiTap() {
+    this.resampler = (buffer) => {
+      let bufferLength = buffer.length,
+        outLength,
+        output_variable_list,
+        channels = this.channels,
+        ratioWeight,
+        weight,
+        channel,
+        actualPosition,
+        amountToNext,
+        alreadyProcessedTail,
+        outputBuffer,
+        outputOffset,
+        currentPosition;
+
+      if ((bufferLength % channels) !== 0) {
+        throw (new Error("Buffer was of incorrect sample length."));
+      }
+      if (bufferLength <= 0) {
+        return [];
+      }
+
+      outLength = this.outputBufferSize;
+      output_variable_list = [];
+      ratioWeight = this.ratioWeight;
+      weight = 0;
+      actualPosition = 0;
+      amountToNext = 0;
+      alreadyProcessedTail = !this.tailExists;
+      this.tailExists = false;
+      outputBuffer = this.outputBuffer;
+      outputOffset = 0;
+      currentPosition = 0;
+
+      for (channel = 0; channel < channels; ++channel) {
+        output_variable_list[channel] = 0;
+      }
+
+      do {
+        if (alreadyProcessedTail) {
+          weight = ratioWeight;
+          for (channel = 0; channel < channels; ++channel) {
+            output_variable_list[channel] = 0;
+          }
+        } else {
+          weight = this.lastWeight;
+          for (channel = 0; channel < channels; ++channel) {
+            output_variable_list[channel] = this.lastOutput[channel];
+          }
+          alreadyProcessedTail = true;
+        }
+        while (weight > 0 && actualPosition < bufferLength) {
+          amountToNext = 1 + actualPosition - currentPosition;
+          if (weight >= amountToNext) {
+            for (channel = 0; channel < channels; ++channel) {
+              output_variable_list[channel] += buffer[actualPosition++] * amountToNext;
+            }
+            currentPosition = actualPosition;
+            weight -= amountToNext;
+          } else {
+            for (channel = 0; channel < channels; ++channel) {
+              output_variable_list[channel] += buffer[actualPosition + ((channel > 0) ? channel : 0)] * weight;
+            }
+            currentPosition += weight;
+            weight = 0;
+            break;
+          }
+        }
+
+        if (weight === 0) {
+          for (channel = 0; channel < channels; ++channel) {
+            outputBuffer[outputOffset++] = output_variable_list[channel] / ratioWeight;
+          }
+        } else {
+          this.lastWeight = weight;
+          for (channel = 0; channel < channels; ++channel) {
+            this.lastOutput[channel] = output_variable_list[channel];
+          }
+          this.tailExists = true;
+          break;
+        }
+      } while (actualPosition < bufferLength && outputOffset < outLength);
+      return this.bufferSlice(outputOffset);
+    };
+  }
+
+  resample(buffer) {
+    if (this.fromSampleRate == this.toSampleRate) {
+      this.ratioWeight = 1;
+    } else {
+      if (this.fromSampleRate < this.toSampleRate) {
+        this.lastWeight = 1;
+      } else {
+        this.tailExists = false;
+        this.lastWeight = 0;
+      }
+      this.initializeBuffers();
+      this.ratioWeight = this.fromSampleRate / this.toSampleRate;
+    }
+    return this.resampler(buffer)
+  }
+}
+
+registerProcessor("recorder.worklet", RecorderProcessor)
\ No newline at end of file
diff --git a/lib/pages/chat/events/message_content.dart b/lib/pages/chat/events/message_content.dart
index 4de934d..c8c0221 100644
--- a/lib/pages/chat/events/message_content.dart
+++ b/lib/pages/chat/events/message_content.dart
@@ -110,7 +110,7 @@ class MessageContent extends StatelessWidget {
     switch (event.type) {
       case PollEvents.PollStart:
         Logs().v("Got poll event ${event.type}");
-        return PollWidget(event, color: textColor, linkColor: linkColor, fontSize: fontSize);
+        return PollWidget(event, color: textColor, linkColor: linkColor, fontSize: fontSize, timeline: timeline);
       case EventTypes.Message:
       case EventTypes.Encrypted:
       case EventTypes.Sticker:
diff --git a/lib/pages/chat/events/poll_content.dart b/lib/pages/chat/events/poll_content.dart
index d69b27a..c9214ef 100644
--- a/lib/pages/chat/events/poll_content.dart
+++ b/lib/pages/chat/events/poll_content.dart
@@ -1,6 +1,5 @@
 import 'package:extera_next/utils/poll_events.dart';
 import 'package:flutter/material.dart';
-import 'package:flutter/widgets.dart';
 import 'package:matrix/matrix.dart';
 
 class PollWidget extends StatefulWidget {
@@ -8,37 +7,391 @@ class PollWidget extends StatefulWidget {
   final Color linkColor;
   final double fontSize;
   final Event event;
+  final Timeline timeline;
 
   const PollWidget(
     this.event, {
     required this.color,
     required this.linkColor,
     required this.fontSize,
+    required this.timeline,
     super.key,
   });
-  
+
   @override
   State<StatefulWidget> createState() => PollWidgetState();
 }
 
 class PollWidgetState extends State<PollWidget> {
+  List<String> selectedAnswers = [];
+  List<String> originalVote = []; // Store the original vote to detect changes
+  Map<String, int>? pollResults;
+  bool hasVoted = false;
+  bool isLoading = false;
+
+  @override
+  void initState() {
+    super.initState();
+    _loadPollData();
+  }
+
+  void _loadPollData() {
+    final event = widget.event;
+    final content =
+        event.content[PollEvents.PollStart] as Map<String, dynamic>;
+
+    // Check if user has already voted
+    _checkExistingVote();
+
+    // For disclosed polls, load initial results
+    final kind = content['kind'] as String?;
+    if (kind == 'org.matrix.msc3381.disclosed') {
+      _calculateResults();
+    }
+  }
+
+  void _checkExistingVote() {
+    final room = widget.event.room;
+    final currentUserId = room.client.userID;
+
+    
+
+    // Find existing poll response events from current user
+    final responses = widget.timeline!.events.where((e) {
+      return e.type == 'org.matrix.msc3381.poll.response' &&
+          e.senderId == currentUserId &&
+          e.relationshipEventId == widget.event.eventId;
+    }).toList();
+
+    if (responses.isNotEmpty) {
+      // Use the latest response
+      final latestResponse = responses.last;
+      final responseContent = latestResponse
+          .content['org.matrix.msc3381.poll.response'] as Map<String, dynamic>;
+      if (responseContent != null) {
+        final List<dynamic> answers = responseContent['answers'];
+        setState(() {
+          selectedAnswers = answers.cast<String>();
+          originalVote = List.from(answers.cast<String>()); // Store original vote
+          hasVoted = true;
+        });
+      }
+    }
+  }
+
+  void _calculateResults() {
+    final room = widget.event.room;
+    final pollEventId = widget.event.eventId;
+    final results = <String, int>{};
+
+    
+
+    // Get all poll response events for this poll
+    final responses = widget.timeline!.events.where((e) {
+      return e.type == 'org.matrix.msc3381.poll.response' &&
+          e.relationshipEventId == pollEventId;
+    }).toList();
+
+    // Count votes for each answer
+    for (final response in responses) {
+      final responseContent = response
+          .content['org.matrix.msc3381.poll.response'] as Map<String, dynamic>;
+      if (responseContent != null) {
+        final List<dynamic> answers = responseContent['answers'];
+        for (final answer in answers.cast<String>()) {
+          results[answer] = (results[answer] ?? 0) + 1;
+        }
+      }
+    }
+
+    setState(() {
+      pollResults = results;
+    });
+  }
+
+  Future<void> _vote(List<String> answers) async {
+    if (isLoading) return;
+
+    setState(() {
+      isLoading = true;
+    });
+
+    try {
+      final room = widget.event.room;
+
+      // Send poll response event
+      await room.sendEvent(
+        {
+          'm.relates_to': {
+            'rel_type': 'm.reference',
+            'event_id': widget.event.eventId,
+          },
+          'org.matrix.msc3381.poll.response': {
+            'answers': answers,
+          },
+        },
+        type: 'org.matrix.msc3381.poll.response'
+      );
+
+      setState(() {
+        selectedAnswers = answers;
+        originalVote = List.from(answers); // Update original vote after voting
+        hasVoted = true;
+        isLoading = false;
+      });
+
+      // Recalculate results for disclosed polls
+      final content =
+          widget.event.content[PollEvents.PollStart] as Map<String, dynamic?>;
+      final kind = content['kind'] as String?;
+      if (kind == 'org.matrix.msc3381.disclosed') {
+        _calculateResults();
+      }
+    } catch (e) {
+      setState(() {
+        isLoading = false;
+      });
+      // Show error message
+      if (mounted) {
+        ScaffoldMessenger.of(context).showSnackBar(
+          SnackBar(
+            content: Text('Failed to vote: $e'),
+            backgroundColor: Colors.red,
+          ),
+        );
+      }
+    }
+  }
+
+  void _onAnswerSelected(String answerId, bool selected) {
+    final content =
+        widget.event.content[PollEvents.PollStart] as Map<String, dynamic?>;
+    final maxSelections = content['max_selections'] as int? ?? 1;
+    final List<dynamic> answers = content['answers'];
+
+    setState(() {
+      if (maxSelections == 1) {
+        // Single selection - replace current selection
+        selectedAnswers = selected ? [answerId] : [];
+      } else {
+        // Multiple selection
+        if (selected) {
+          if (selectedAnswers.length < maxSelections) {
+            selectedAnswers.add(answerId);
+          }
+        } else {
+          selectedAnswers.remove(answerId);
+        }
+      }
+    });
+  }
+
+  bool _isPollEnded() {
+    final room = widget.event.room;
+    if (widget.timeline == null) return false;
+    // Check if there's an end event for this poll
+    final endEvents = widget.timeline!.events.where((e) {
+      return e.type == 'org.matrix.msc3381.poll.end' &&
+          e.senderId == widget.event.senderId &&
+          e.relationshipEventId == widget.event.eventId;
+    });
+    return endEvents.isNotEmpty;
+  }
+
+  bool _shouldShowResults() {
+    final content =
+        widget.event.content[PollEvents.PollStart] as Map<String, dynamic?>;
+    final kind = content['kind'] as String?;
+    final isDisclosed = kind == 'org.matrix.msc3381.disclosed';
+    final isEnded = _isPollEnded();
+
+    return isDisclosed || isEnded || hasVoted;
+  }
+
+  double _getAnswerPercentage(String answerId) {
+    if (pollResults == null || pollResults!.isEmpty) return 0.0;
+
+    final totalVotes = pollResults!.values.reduce((a, b) => a + b);
+    if (totalVotes == 0) return 0.0;
+
+    return pollResults![answerId]?.toDouble() ?? 0 / totalVotes.toDouble();
+  }
+
+  // Check if the current selection is different from the original vote
+  bool _hasSelectionChanged() {
+    if (selectedAnswers.length != originalVote.length) return true;
+    
+    // Sort both lists to compare regardless of order
+    final sortedSelected = List.from(selectedAnswers)..sort();
+    final sortedOriginal = List.from(originalVote)..sort();
+    
+    for (int i = 0; i < sortedSelected.length; i++) {
+      if (sortedSelected[i] != sortedOriginal[i]) return true;
+    }
+    
+    return false;
+  }
+
   @override
   Widget build(BuildContext context) {
     final event = widget.event;
-    final content = event.content[PollEvents.PollStart] as Map<String, dynamic?>;
+    final content =
+        event.content[PollEvents.PollStart] as Map<String, dynamic?>;
+    final question = content?['question']?['m.text'] as String? ?? 'Poll';
+    final List<dynamic> answers = content?['answers'] ?? [];
+    final maxSelections = content?['max_selections'] as int? ?? 1;
+    final kind = content?['kind'] as String?;
+
+    final shouldShowResults = _shouldShowResults();
+    final isEnded = _isPollEnded();
+    final canVote = !isEnded && !isLoading;
+    final hasChanged = _hasSelectionChanged();
+
     return Padding(
-      padding: EdgeInsetsGeometry.all(16),
+      padding: const EdgeInsets.all(16),
       child: Column(
+        crossAxisAlignment: CrossAxisAlignment.start,
         children: [
-          Text(content?['question']['m.text'] as String, style: TextStyle(fontWeight: FontWeight.bold)),
-          Padding(
-            padding: EdgeInsets.fromLTRB(4, 4, 4, 2),
-            child: Column(
-              children: [
-                
-              ],
+          // Question
+          Text(
+            question,
+            style: TextStyle(
+              fontWeight: FontWeight.bold,
+              fontSize: widget.fontSize,
+              color: widget.color,
+            ),
+          ),
+          const SizedBox(height: 12),
+
+          // Answers
+          ...answers.asMap().entries.map((entry) {
+            final index = entry.key;
+            final answer = entry.value as Map<String, dynamic>;
+            final answerId = answer['id'] as String;
+            final answerText = answer['m.text'] as String? ??
+                answer['org.matrix.msc1767.text'] as String? ??
+                'Answer ${index + 1}';
+            final isSelected = selectedAnswers.contains(answerId);
+            final percentage = _getAnswerPercentage(answerId);
+            final voteCount = pollResults?[answerId] ?? 0;
+
+            return Padding(
+              padding: const EdgeInsets.only(bottom: 8),
+              child: Column(
+                crossAxisAlignment: CrossAxisAlignment.start,
+                children: [
+                  // Answer row
+                  Row(
+                    children: [
+                      // Selection indicator
+                      if (canVote) ...[
+                        if (maxSelections == 1)
+                          Radio<bool>(
+                            value: true,
+                            groupValue: isSelected,
+                            onChanged: (_) =>
+                                _onAnswerSelected(answerId, !isSelected),
+                          )
+                        else
+                          Checkbox(
+                            value: isSelected,
+                            onChanged: (_) =>
+                                _onAnswerSelected(answerId, !isSelected),
+                          ),
+                      ] else if (isSelected)
+                        Icon(Icons.check, color: Colors.green, size: 20),
+
+                      Expanded(
+                        child: GestureDetector(
+                          onTap: canVote
+                              ? () => _onAnswerSelected(answerId, !isSelected)
+                              : null,
+                          child: Text(
+                            answerText,
+                            style: TextStyle(
+                              fontSize: widget.fontSize - 1,
+                              color: widget.color.withOpacity(0.9),
+                            ),
+                          ),
+                        ),
+                      ),
+
+                      // Vote count and percentage
+                      if (shouldShowResults && pollResults != null)
+                        Text(
+                          '${(percentage * 100).toStringAsFixed(1)}% ($voteCount)',
+                          style: TextStyle(
+                            fontSize: widget.fontSize - 2,
+                            color: widget.color.withOpacity(0.7),
+                          ),
+                        ),
+                    ],
+                  ),
+
+                  // Progress bar
+                  if (shouldShowResults && pollResults != null)
+                    Padding(
+                      padding: const EdgeInsets.only(top: 4, left: 40),
+                      child: LinearProgressIndicator(
+                        value: percentage,
+                        backgroundColor: widget.color.withOpacity(0.2),
+                        valueColor: AlwaysStoppedAnimation<Color>(
+                          isSelected
+                              ? Colors.blue
+                              : widget.color.withOpacity(0.5),
+                        ),
+                      ),
+                    ),
+                ],
+              ),
+            );
+          }),
+
+          const SizedBox(height: 12),
+
+          // Vote button and info
+          Row(
+            children: [
+              if (canVote && selectedAnswers.isNotEmpty)
+                // Show "Change Vote" button only when selection has changed
+                if (!hasVoted || (hasVoted && hasChanged))
+                  ElevatedButton(
+                    onPressed: isLoading ? null : () => _vote(selectedAnswers),
+                    child: isLoading
+                        ? const SizedBox(
+                            width: 16,
+                            height: 16,
+                            child: CircularProgressIndicator(strokeWidth: 2),
+                          )
+                        : Text(hasVoted ? 'Change Vote' : 'Vote'),
+                  ),
+
+              const Spacer(),
+
+              // Poll info
+              Text(
+                '${maxSelections == 1 ? 'Single' : 'Multiple'} choice • '
+                '${kind?.contains('undisclosed') == true ? 'Anonymous' : 'Public'} • '
+                '${isEnded ? 'Ended' : 'Active'}',
+                style: TextStyle(
+                  fontSize: widget.fontSize - 2,
+                  color: widget.color.withOpacity(0.6),
+                ),
+              ),
+            ],
+          ),
+
+          if (selectedAnswers.isNotEmpty && maxSelections > 1)
+            Padding(
+              padding: const EdgeInsets.only(top: 8),
+              child: Text(
+                '${selectedAnswers.length} of $maxSelections selected',
+                style: TextStyle(
+                  fontSize: widget.fontSize - 2,
+                  color: widget.color.withOpacity(0.6),
+                ),
+              ),
             ),
-          )
         ],
       ),
     );
diff --git a/lib/pages/chat/send_file_dialog.dart b/lib/pages/chat/send_file_dialog.dart
index d3a34ca..853ca2a 100644
--- a/lib/pages/chat/send_file_dialog.dart
+++ b/lib/pages/chat/send_file_dialog.dart
@@ -1,5 +1,6 @@
 import 'dart:typed_data';
 
+import 'package:extera_next/config/app_config.dart';
 import 'package:extera_next/utils/clean_exif.dart';
 import 'package:extera_next/widgets/matrix.dart';
 import 'package:flutter/cupertino.dart';
@@ -12,7 +13,6 @@ import 'package:mime/mime.dart';
 
 import 'package:extera_next/utils/localized_exception_extension.dart';
 import 'package:extera_next/utils/matrix_sdk_extensions/matrix_file_extension.dart';
-import 'package:extera_next/utils/other_party_can_receive.dart';
 import 'package:extera_next/utils/platform_infos.dart';
 import 'package:extera_next/utils/size_string.dart';
 import 'package:extera_next/widgets/adaptive_dialogs/adaptive_dialog_action.dart';
@@ -79,7 +79,7 @@ class SendFileDialogState extends State<SendFileDialog> {
           if (length > maxUploadSize) {
             throw FileTooBigMatrixException(length, maxUploadSize);
           }
-
+        
           // Else we just create a MatrixFile
           file = MatrixFile(
             bytes: Uint8List.fromList(ExifCleaner.removeExifData(await xfile.readAsBytes())),
